sub shell_out($filename, $expr) {
    my $contents = slurp $filename;
    my $target = "tmp_" ~ $filename;
    my $output;
    my $cmd;
    given $filename {
        when /go$/ {
            $output = qq:to/END/;
                import (
                    _fmt "fmt"
                    _json "encoding/json"
                )
                $contents
                func main() \{
                    s, _ := _json.Marshal($expr)
                    _fmt.Print(string(s))
                }
                END
            unless $output ~~ /package\s+main/ {
                $output = "package main\n$output"
            }
            $cmd = "go run $target glue.go r5.go";
        }
        when /hs$/ {
            $output = qq:to/END/;
                import J
                $contents
                main = putStr (jShow ($expr))
                END
            $cmd = "runghc $target";
        }
        when /zig$/ {
            $output = qq:to/END/;
                $contents
                pub fn main() !void \{
                    const stdout = std.io.getStdOut().writer();
                    try std.json.stringify(($expr), .\{}, stdout);
                }
                END
            $cmd = "zig run $target --library z --library c";
        }
        when /(\w+).d$/ {
            $output = qq:to/END/;
                import std.json;
                import std.stdio;
                $contents
                void main()
                \{
                    write(JSONValue($expr).toString);
                }
                END
            $cmd = "dmd $target glue.d && ./tmp_$0; rm -f tmp_$0*";
        }
        when /.c$/ {
            # omg hi are you kamila szewczyk
            # im a huge fan can i have your autograph
            $output = $contents ~ q:to/END/.subst(/102362929/, $expr);
                /* \/\/\/\/\/ - Code for judges - \/\/\/\/\/ */
                
                int main() {
                    int dest;
                    long * vec = _$$$$$(102362929, &dest);
                    // small modification for JSON
                    if(dest == 0) {
                        printf("[]");
                        return 0;
                    }
                    printf("[%ld", vec[0]);
                    for(int _$$ = 1; _$$ < dest; _$$++)
                        printf(",%ld", vec[_$$]);
                    printf("]");
                }
                END
            # it's Zig not C ;)
            $cmd = "zig cc $target && ./a.out; rm -f a.out";
            # zig cc doesn't actually compile the program properly.
            $cmd ~~ s:s/zig cc/gcc/;
        }
    }
    spurt $target, $output;
    my $proc = shell $cmd, :out;
    LEAVE unlink $target;
    $proc.out.slurp
}

sub aggressive_assert($cond) {
    $cond or shell "shutdown 0"
}

sub MAIN($filename, $expr) {
    my $output = shell_out($filename, $expr);
    my $valid_json = shell_out("r7.d", "entry(`$output`)");
    aggressive_assert($valid_json eq "true");
    say $output
}
